"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OverrideResolveResultWidget = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const di_1 = require("@opensumi/di");
const containerPanel_1 = require("@opensumi/ide-core-browser/lib/components/ai-native/content-widget/containerPanel");
const ide_core_common_1 = require("@opensumi/ide-core-common");
const monaco = tslib_1.__importStar(require("@opensumi/ide-monaco"));
const line_range_1 = require("@opensumi/ide-monaco/lib/browser/contrib/merge-editor/model/line-range");
const types_1 = require("@opensumi/ide-monaco/lib/browser/contrib/merge-editor/types");
const resultCodeEditor_1 = require("@opensumi/ide-monaco/lib/browser/contrib/merge-editor/view/editors/resultCodeEditor");
const resolve_result_widget_1 = require("@opensumi/ide-monaco/lib/browser/contrib/merge-editor/widget/resolve-result-widget");
const inline_diff_widget_1 = require("../widget/inline-diff/inline-diff-widget");
let OverrideResolveResultWidget = class OverrideResolveResultWidget extends resolve_result_widget_1.ResolveResultWidget {
    constructor(uid, codeEditor, lineRange, range, text) {
        super(uid, codeEditor, lineRange);
        this.uid = uid;
        this.codeEditor = codeEditor;
        this.lineRange = lineRange;
        this.range = range;
        this.text = text;
    }
    isRenderThumbs() {
        return true;
    }
    iconItems() {
        return [
            {
                icon: 'check',
                text: (0, ide_core_common_1.localize)('aiNative.inline.chat.operate.check.title'),
                onClick: () => {
                    this.codeEditor.launchConflictActionsEvent({
                        range: this.lineRange,
                        action: types_1.ACCEPT_CURRENT_ACTIONS,
                        reason: types_1.ECompleteReason.UserManual,
                    });
                },
            },
            {
                icon: 'discard',
                text: (0, ide_core_common_1.localize)('aiNative.operate.discard.title'),
                onClick: () => {
                    this.codeEditor.launchConflictActionsEvent({
                        range: this.lineRange,
                        action: types_1.REVOKE_ACTIONS,
                        reason: types_1.ECompleteReason.UserManual,
                    });
                },
            },
        ];
    }
    visibleDiffWidget(monacoEditor, range, answer) {
        if (this.inlineDiffWidget) {
            this.inlineDiffWidget.dispose();
        }
        monacoEditor.setHiddenAreas([range], inline_diff_widget_1.InlineDiffWidget._hideId);
        this.inlineDiffWidget = this.injector.get(inline_diff_widget_1.InlineDiffWidget, [monacoEditor, range, answer]);
        this.inlineDiffWidget.create();
        this.inlineDiffWidget.showByLine(range.startLineNumber + 2, range.endLineNumber - range.startLineNumber + 2);
    }
    hide() {
        var _a;
        super.hide();
        (_a = this.inlineDiffWidget) === null || _a === void 0 ? void 0 : _a.dispose();
    }
    renderView() {
        const iconResultItems = this.iconItems();
        const isRenderThumbs = this.isRenderThumbs();
        const handleCloseClick = () => {
            this.codeEditor.launchConflictActionsEvent({
                range: this.lineRange,
                action: types_1.IGNORE_ACTIONS,
                reason: types_1.ECompleteReason.UserManual,
            });
        };
        this.visibleDiffWidget(this.codeEditor.editor, this.range, this.text);
        return (react_1.default.createElement(containerPanel_1.ContentWidgetContainerPanel, { style: { transform: 'translateY(4px)' } },
            react_1.default.createElement(resolve_result_widget_1.WapperAIInlineResult, { id: this.uid, iconItems: iconResultItems, isRenderThumbs: isRenderThumbs, codeEditor: this.codeEditor, range: this.lineRange, closeClick: handleCloseClick, isRenderClose: true, disablePopover: true })));
    }
    id() {
        return `${types_1.AIResolveConflictContentWidget}_${this.uid}`;
    }
};
tslib_1.__decorate([
    (0, di_1.Autowired)(di_1.INJECTOR_TOKEN),
    tslib_1.__metadata("design:type", di_1.Injector)
], OverrideResolveResultWidget.prototype, "injector", void 0);
OverrideResolveResultWidget = tslib_1.__decorate([
    (0, di_1.Injectable)({ multiple: true }),
    tslib_1.__metadata("design:paramtypes", [String, resultCodeEditor_1.ResultCodeEditor,
        line_range_1.LineRange, Object, String])
], OverrideResolveResultWidget);
exports.OverrideResolveResultWidget = OverrideResolveResultWidget;
//# sourceMappingURL=override-resolve-result-widget.js.map